var groovesharkProxy = {
  prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
  prefManager: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
  observerService: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),

  init: function() {
    this.observerService.addObserver(this.observe, "http-on-modify-request", false);
  },

  start: function() {
    getBrowser().loadURI("http://listen.grooveshark.com");
  },

  setProxy: function() {
    this.prefs.setIntPref("network.proxy.type", 1);
    this.prefs.setCharPref("network.proxy.http", this.prefManager.getCharPref("extensions.groovesharkProxy.proxy"));
    this.prefs.setIntPref("network.proxy.http_port", this.prefManager.getIntPref("extensions.groovesharkProxy.port"));    
    window.setTimeout(function(ref) {ref.resetProxy();}, 3000, this);
  },

  resetProxy: function() {
    this.prefs.setIntPref("network.proxy.type", 5);
    this.prefs.setCharPref("network.proxy.http", "");
    this.prefs.setIntPref("network.proxy.http_port", 0);
    this.observerService.addObserver(this.observe, "http-on-modify-request", false);
  },
  
  observe: function(aSubject, aTopic, aData) {
    if(aTopic=="http-on-modify-request") {
      var url = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel).originalURI.spec;
      if(url.match(/^http\:\/\/(www\.)?grooveshark\.com\/$/i)) {
        aSubject.cancel(Components.results.NS_ERROR_NO_CONTENT);
        groovesharkProxy.setProxy();
        window.setTimeout(function(ref) {ref.start();}, 10, groovesharkProxy);
        groovesharkProxy.observerService.removeObserver(groovesharkProxy.observe, "http-on-modify-request");
      }
    }
  }
};

groovesharkProxy.init();
